/*  Ton mit Timer  Ausgabe an P0.6  */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t ton=0;
uint16_t periode;					// Timerperiode = AD-Wert
int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe damit alle LEDs aus, nur 1 Bit notwendig
  timer_init(8,1000);				// Vorteiler 2^8=256 -> 64MHz / 256 = 250kHz Anfangsperiode 1000
  timer_start_interrupt();			// Timer mit Interrupt starten, in ISR wird Bit für Ton invertiert
  bit_init(P0,6,OUTP);				// Ausgabe
  adc_init();						// ADC initialisieren (Poti links)
  while(1U)							// Endlosschleife, immer bei Controllern
  {
	  periode = adc_in(0);			// Periodendauer ton von ADC holen
	  if (periode > 10) timer_init(6,periode); // wenn periode zu klein: Programmabsturz
  }//while
}//main

//********* Interrupt-Service-Routine bei Timerüberlauf**********************
void CCU40_3_IRQHandler (void) // Timer ISR
{
	bit_write(P0,6,ton);			// Tonausgabe = Rechteckspannung
	ton =~ton;						// Bit invertieren für Rechteck
}
