/* Farbuebergaenge RGB-LED mit PWM steuern: R an P0.6, G an P0.7, B an P0.8  */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t z;			// Zählvariable
#define aus 0
#define an 255
#define heller 1
#define dunkler 254

void RGBuebergang (uint8_t rot,uint8_t gruen,uint8_t blau,uint16_t time)
{   uint8_t s,tgr,tgg,tgb;
	for (s=0;s!=255;s++)	// Tastgrad größer oder kleiner 0...255 oder 255..0
	{
	 if (rot == heller) tgr = s; 	else if (rot == dunkler) tgr = ~s; 		else tgr = rot;
	 if (gruen == heller) tgg = s; 	else if (gruen == dunkler) tgg = ~s; 	else tgg = gruen;
	 if (blau == heller) tgb = s; 	else if (blau == dunkler) tgb = ~s; 	else tgb = blau;
	 pwm1_duty_cycle(~tgr);		// Tastgrade
	 pwm2_duty_cycle(~tgg);
	 pwm3_duty_cycle(~tgb);
	 delay_ms(time);
	}
}

int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe damit alle anderen LEDs aus
  pwm1_init();						// PWM Kanal 0 initialisieren
  pwm2_init();						// PWM Kanal 1 initialisieren
  pwm3_init();						// PWM Kanal 1 initialisieren
  pwm1_start();						// Ausgabe starten
  pwm2_start();						// Ausgabe starten
  pwm3_start();						// Ausgabe starten
  while(1U)							// Endlosschleife, immer bei Controllern
  {	//				R		G		B		zeit
	RGBuebergang (	heller,	aus,	aus,	10) ;
	RGBuebergang (	an,		heller,	aus,	10) ;
	RGBuebergang (	dunkler,	an,	heller,	10) ;
	RGBuebergang (	aus,	dunkler,an,		10) ;
	RGBuebergang (	heller,	heller,	dunkler,10) ;
	RGBuebergang (	dunkler,dunkler,aus,	10) ;
  }//while
}//main

